using UnityEngine;

public struct AnakinResources
{
    public static AudioClip SpartanLaserCharge;
    public static AudioClip SpartanLaserFire;
    public static AudioClip SpartanLaserExit;

    public static AudioClip EnergySwordHum;
    public static AudioClip EnergySwordIgnite;
    public static AudioClip EnergySwordOff;
    public static AudioClip[] EnergySwordHits;
    public static AudioClip[] PlasmaPistolFire;
    public static AudioClip[] PlasmaRifleFire;
    public static AudioClip[] NeedleFire;
    public static AudioClip[] NeedleExplode;
    public static AudioClip PlasmaRifleOverheat;
    public static AudioClip PlasmaPistolChargeStart;
    public static AudioClip PlasmaPistolLoop;
    public static AudioClip PlasmaPistolChargedShot;

    public static Sprite EnergySwordHilt;
    public static Sprite EnergySwordBlade;
    public static Sprite SpartanLaser;
    public static Sprite PlasmaPistol;
    public static Sprite PlasmaRifle;
    public static Sprite PlasmaRifleGlow;
    public static Sprite Needler;
    public static Sprite Needle;

    public static Sprite Particle;
    public static Sprite PlasmaBolt;
    public static Sprite EnergyFlash;

    public static void Initialise()
    {
        Particle = ModAPI.LoadSprite("particle.png");
        EnergyFlash = ModAPI.LoadSprite("flash.png");

        SpartanLaserCharge = ModAPI.LoadSound("sfx/spartan_laser_charge.wav");
        SpartanLaserFire = ModAPI.LoadSound("sfx/spartan_laser_fire.wav");
        SpartanLaserExit = ModAPI.LoadSound("sfx/spartan_laser_exit.wav");

        EnergySwordHum = ModAPI.LoadSound("SaberSFX/idle.wav");
        EnergySwordIgnite = ModAPI.LoadSound("SaberSFX/dark_on.mp3");
        EnergySwordOff = ModAPI.LoadSound("SaberSFX/dark_off.mp3");

        PlasmaRifleOverheat = ModAPI.LoadSound("sfx/plasma_rifle_overheat.wav");

        PlasmaPistolChargeStart = ModAPI.LoadSound("sfx/plasma_pistol_start.wav");
        PlasmaPistolLoop = ModAPI.LoadSound("sfx/plasma_pistol_loop.wav");
        PlasmaPistolChargedShot = ModAPI.LoadSound("sfx/plasma_pistol_charged.wav");

        EnergySwordHits = new[]{
            ModAPI.LoadSound("SaberSFX/hit_1.mp3"),
            ModAPI.LoadSound("SaberSFX/hit_2.mp3"),
            ModAPI.LoadSound("SaberSFX/hit_3.mp3"),
            ModAPI.LoadSound("SaberSFX/hit_4.mp3"),
        };

        PlasmaPistolFire = new[]{
            ModAPI.LoadSound("sfx/plasma_pistol1.wav"),
            ModAPI.LoadSound("sfx/plasma_pistol2.wav"),
            ModAPI.LoadSound("sfx/plasma_pistol3.wav"),
        };

        PlasmaRifleFire = new[]{
            ModAPI.LoadSound("sfx/plasma_rifle1.wav"),
            ModAPI.LoadSound("sfx/plasma_rifle2.wav"),
            ModAPI.LoadSound("sfx/plasma_rifle3.wav"),
        };

        NeedleFire = new[]{
            ModAPI.LoadSound("sfx/needler_fire1.wav"),
            ModAPI.LoadSound("sfx/needler_fire2.wav"),
            ModAPI.LoadSound("sfx/needler_fire3.wav"),
        };

        NeedleExplode = new[]{
            ModAPI.LoadSound("sfx/needle_explode1.wav"),
            ModAPI.LoadSound("sfx/needle_explode2.wav"),
            ModAPI.LoadSound("sfx/needle_explode3.wav"),
        };

        EnergySwordHilt = ModAPI.LoadSprite("Anakin.png", 2.8f);
        EnergySwordBlade = ModAPI.LoadSprite("VaderBlade.png", 2.8f);
        SpartanLaser = ModAPI.LoadSprite("Spartan Laser.png");
        PlasmaPistol = ModAPI.LoadSprite("Plasma Pistol.png");
        PlasmaRifle = ModAPI.LoadSprite("Plasma Rifle.png");
        PlasmaRifleGlow = ModAPI.LoadSprite("Plasma Rifle Glow.png");
        Needler = ModAPI.LoadSprite("Needler.png");
        Needle = ModAPI.LoadSprite("Needle.png");
        PlasmaBolt = ModAPI.LoadSprite("bolt.png");
    }
}
