using UnityEngine;

namespace Mod
{
    public class Mod
    {
		
        public const float PixelSize = Global.MetricMultiplier / 35f;

        public static void Main()
        {
            Resources.Initialise();            
            AddUnique<EnergySwordBehaviourRed>("Vader", "Desc");
		}
		
        private static void AddUnique<T>(string name, string desc, string original = "Rod") where T : Component
        {
			CategoryBuilder.Create("BBQ's Lightsaber", "Breathe.....", ModAPI.LoadSprite("category.png"));
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "<color=#404040>[Lightsaber]<color=white>Darth Vader's Lightsaber",
                    NameToOrderByOverride = "AAAAAAAAAAAAAAAAAAAA000000",
                    DescriptionOverride = "You don't know the power of DARK SIDE",
                    CategoryOverride = ModAPI.FindCategory("BBQ's Lightsaber"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb1.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Weapon");
                        Instance.GetOrAddComponent<T>();
						Instance.GetComponent<PhysicalBehaviour>().ReflectsLasers = true;
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vader.png", 2.8f);
						Instance.FixColliders();
                    }
                }
            );
        private static void AddUnique<T>(string name, string desc, string original = "Rod") where T : Component
		{
		    ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "<color=#404040>[Lightsaber]<color=white>Anakin Skywalker's Lightsaber",
                    NameToOrderByOverride = "AAAAAAAAAAAAAAAAAAAA000002",
                    DescriptionOverride = "You don't know the power of DARK SIDE",
                    CategoryOverride = ModAPI.FindCategory("BBQ's Lightsaber"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb2.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Weapon");
                        Instance.GetOrAddComponent<T>();
						Instance.GetComponent<PhysicalBehaviour>().ReflectsLasers = true;
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Anakin.png", 2.8f);
						Instance.FixColliders();
                    }
                }
            );
        }
	}
}