using UnityEngine;

namespace Lightsaber
{
    public class StarWarsBlasterBehaviour : CanShoot
    {
        private PhysicalBehaviour physicalBehaviour;
        private Vector2 barrelPosition = new Vector2(.5f, .06f);
        private Vector2 barrelDirection = new Vector2(1, 0);

        public AudioClip Clip;
        public Color Color;

        private void Awake()
        {
            physicalBehaviour = GetComponent<PhysicalBehaviour>();
        }

        private void Use()
        {
            Shoot();
        }

        private void OnWillRenderObject(){
            foreach (var item in GetComponents<Collider2D>())
            {
                ModAPI.Draw.Collider(item);
            }
        }

        public override void Shoot()
        {
            var pos = BarrelPosition;
            var dir = BarrelDirection;

            physicalBehaviour.rigidbody.AddForceAtPosition(dir * -5, pos, ForceMode2D.Impulse);
            var bolt = new GameObject("bolt", typeof(StarWarsBlasterboltBehaviour));
            bolt.transform.position = pos;
            bolt.transform.right = dir;
            bolt.GetComponent<SpriteRenderer>().color = Color * .3f;
            for (int i = 0; i < 4; i++) // this is an awful way to make something louder, never do this. im only doing this because i cant be fucked to put that much effort into a mod
                physicalBehaviour.PlayClipOnce(Clip);
            CameraShakeBehaviour.main.Shake(.5f, pos);
        }

        public override Vector2 BarrelPosition { get { return transform.TransformPoint(barrelPosition); } }

        public Vector2 BarrelDirection { get { return transform.TransformDirection(barrelDirection) * transform.localScale.x; } }
    }
}