using UnityEngine;

namespace Mod
{
    public class Mod
    {
        public const float PixelSize = Global.MetricMultiplier / 35f;

        public static void Main()
        {
            Resources.Initialise();            
            AddUnique<EnergySwordBehaviour>("saber", "hell yeah");
			
		}
		
		private static void AddUnique<T>(string name, string desc, string original = "Rod") where T : Component
        {     
			CategoryBuilder.Create("BBQ's Skywalker Saga [Lightsaber]", "Breathe.....", ModAPI.LoadSprite("category.png"));
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "<color=#404040>[Lightsaber]<color=#ffffff> Darth Vader's Lightsaber",
                    DescriptionOverride = "You don't know the power of dark side.",
                    CategoryOverride = ModAPI.FindCategory("BBQ's Skywalker Saga [Lightsaber]"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb1.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Weapon");
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Darth Vader.png", 2.8f);
						Instance.FixColliders();
						Instance.GetOrAddComponent<VaderSwordBehaviour>();
						Instance.GetOrAddComponent<T>();
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Darth Vader.png", 2.8f);
                    }
                }
            );              
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "<color=#404040>[Lightsaber]<color=#ffffff> Anakin Skywalker's Lightsaber",
                    DescriptionOverride = "Are you?",
                    CategoryOverride = ModAPI.FindCategory("BBQ's Skywalker Saga [Lightsaber]"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb2.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Weapon");
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Anakin.png", 2.8f);
						Instance.FixColliders();
						Instance.GetOrAddComponent<AnakinSwordBehaviour>();
						Instance.GetOrAddComponent<T>();
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Anakin.png", 2.8f);
                    }
                }
            );
			 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "<color=#404040>[Lightsaber]<color=#ffffff> Luke Skywalker's Lightsaber",
                    DescriptionOverride = "My father was.",
                    CategoryOverride = ModAPI.FindCategory("BBQ's Skywalker Saga [Lightsaber]"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb3.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Weapon");
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Luke.png", 2.8f);
						Instance.FixColliders();
						Instance.GetOrAddComponent<LukeSwordBehaviour>();
						Instance.GetOrAddComponent<T>();
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Luke.png", 2.8f);
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "<color=#404040>[Lightsaber]<color=#ffffff> Obi Wan Kenobi's Lightsaber",
                    DescriptionOverride = "Hello there!",
                    CategoryOverride = ModAPI.FindCategory("BBQ's Skywalker Saga [Lightsaber]"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb4.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Weapon");
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Kenobi.png", 2.8f);
						Instance.FixColliders();
						Instance.GetOrAddComponent<AnakinSwordBehaviour>();
						Instance.GetOrAddComponent<T>();
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Kenobi.png", 2.8f);
                    }
                }
            );	
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "<color=#404040>[Lightsaber]<color=#ffffff> Cal Kestis' Lightsaber",
                    DescriptionOverride = "Yeah. probably.",
                    CategoryOverride = ModAPI.FindCategory("BBQ's Skywalker Saga [Lightsaber]"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb5.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Weapon");
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Cal.png", 2.8f);
						Instance.FixColliders();
						Instance.GetOrAddComponent<AnakinSwordBehaviour>();
						Instance.GetOrAddComponent<T>();
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Cal.png", 2.8f);
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "<color=#404040>[Lightsaber]<color=#ffffff> Darth Maul's Lightsaber",
                    DescriptionOverride = "KENOBI!!!!",
                    CategoryOverride = ModAPI.FindCategory("BBQ's Skywalker Saga [Lightsaber]"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb6.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Weapon");
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Maul.png", 2.8f);
						Instance.FixColliders();
						Instance.GetOrAddComponent<MaulSwordBehaviour>();
						Instance.GetOrAddComponent<T>();
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Maul.png", 2.8f);
                    }
                }
            );  
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "<color=#404040>[Lightsaber]<color=#ffffff> Darksaber",
                    DescriptionOverride = "",
                    CategoryOverride = ModAPI.FindCategory("BBQ's Skywalker Saga [Lightsaber]"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb7.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Weapon");
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("DarkSaber.png", 2.8f);
						Instance.FixColliders();
						Instance.GetOrAddComponent<MandoSwordBehaviour>();
						Instance.GetOrAddComponent<T>();
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("DarkSaber.png", 2.8f);
                    }
                }
            );		
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "<color=#404040>[Lightsaber]<color=#ffffff> Grand Inquisitor's Lightsaber",
                    DescriptionOverride = "Stay calm.",
                    CategoryOverride = ModAPI.FindCategory("BBQ's Skywalker Saga [Lightsaber]"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb8.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Weapon");
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("InquisitorDouble.png", 2.8f);
						Instance.FixColliders();
						Instance.GetOrAddComponent<InquisitorSwordBehaviour>();
						Instance.GetOrAddComponent<T>();
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("InquisitorDouble.png", 2.8f);
						
						var rotor = new GameObject("rotor");
                        rotor = GameObject.Instantiate(ModAPI.FindSpawnable("Wooden Pillar").Prefab);
                        rotor.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");

                        SpriteRenderer rotorRenderer = rotor.GetComponent<SpriteRenderer>();
                        rotorRenderer.sprite = ModAPI.LoadSprite("RotateHandle.png", 2.8f);
                        rotorRenderer.sortingLayerName = "Default";
						rotor.transform.SetParent(Instance.transform);
                        rotor.transform.localScale = new Vector3(1f, 1f);


                        HingeJoint2D hingeJoint = rotor.GetOrAddComponent<HingeJoint2D>();
                        hingeJoint.connectedBody = Instance.GetComponent<Rigidbody2D>();
                        hingeJoint.anchor = new Vector3(0f, 0f);
                        JointAngleLimits2D limits = hingeJoint.limits;
                        
                        hingeJoint.limits = limits;
                        hingeJoint.useLimits = false;
                        hingeJoint.enableCollision = false;

                        rotor.transform.localPosition = new Vector3(0f, 0f);
						rotor.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.3f;
						rotor.FixColliders();
                    }
                }
            );  
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "<color=#404040>[Lightsaber]<color=#ffffff> Lord Starkiller's Lightsaber",
                    DescriptionOverride = "You don't need to know anything except where I'm going.",
                    CategoryOverride = ModAPI.FindCategory("BBQ's Skywalker Saga [Lightsaber]"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb9.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Weapon");
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Starkiller.png", 2.8f);
						Instance.FixColliders();
						Instance.GetOrAddComponent<GalenSwordBehaviour>();
						Instance.GetOrAddComponent<T>();
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Starkiller.png", 2.8f);
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "<color=#404040>[Lightsaber]<color=#ffffff> Galen Marek's Lightsaber",
                    DescriptionOverride = "You don't need to know anything except where I'm going.",
                    CategoryOverride = ModAPI.FindCategory("BBQ's Skywalker Saga [Lightsaber]"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb10.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Weapon");
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Galen.png", 2.8f);
						Instance.FixColliders();
						Instance.GetOrAddComponent<AnakinSwordBehaviour>();
						Instance.GetOrAddComponent<T>();
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Galen.png", 2.8f);
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "<color=#404040>[Lightsaber]<color=#ffffff> Count Dooku's Lightsaber",
                    DescriptionOverride = "I Would Kill You Both Right Now If I Did Not Have To Drag Your Bodies.",
                    CategoryOverride = ModAPI.FindCategory("BBQ's Skywalker Saga [Lightsaber]"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb11.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Weapon");
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Dooku.png", 2.8f);
						Instance.FixColliders();
						Instance.GetOrAddComponent<VaderSwordBehaviour>();
						Instance.GetOrAddComponent<T>();
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Dooku.png", 2.8f);
                    }
                }
            ); 
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "<color=#ff0086>[Lightsaber]<color=#ffffff> Hartashi's Legacy",
                    DescriptionOverride = "Am I allowed to send 2 screenshots or am I limited to 1?",
                    CategoryOverride = ModAPI.FindCategory("BBQ's Skywalker Saga [Lightsaber]"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb12.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Weapon");
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Hartashi.png", 2.8f);
						Instance.FixColliders();
						Instance.GetOrAddComponent<HartashiSwordBehaviour>();
						Instance.GetOrAddComponent<T>();
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Hartashi.png", 2.8f);
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "<color=#404040>[Lightsaber]<color=#ffffff> Kylo Ren's Lightsaber",
                    DescriptionOverride = "Now I am the supreme leader.",
                    CategoryOverride = ModAPI.FindCategory("BBQ's Skywalker Saga [Lightsaber]"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb13.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Weapon");
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Kylo.png", 2.8f);
						Instance.FixColliders();
						Instance.GetOrAddComponent<RenSwordBehaviour>();
						Instance.GetOrAddComponent<T>();
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Kylo.png", 2.8f);
                    }
                }
            );
        }
    }
}
